<template>
  <modal-component @click-backdrop="clickBackdrop">
    <div class="modal-temple">
      <div class="top-arrow">
        <button @click="goBackToMv">
          <img
            class="animated infinite fadeInDown delay-2s"
            src="../assets/img/scroll_down.png"
            alt="scroll up"
          />
        </button>
      </div>
      <img class="modal-logo" src="../assets/img/legendary_temples.png" alt="ngoi den huyen thoai" />
      <div v-if="!selectedImg" class="modal-list-wrapper">
        <swiper class="modal-list" :options="swiperOption">
          <swiper-slide v-for="(group, index) of getUploadedImages(imgsPerPage)" :key="index">
            <div class="img-item-group">
              <div
                class="img-item"
                v-for="(item, idxItem) of group"
                :key="idxItem"
                @click="onSelectImage(item)"
              >
                <img :src="item" :alt="`ngoi den huyen thoai ${index}`" />
              </div>
            </div>
          </swiper-slide>
        </swiper>
        <div class="modal-list-btns">
          <img class="button-prev" src="../assets/img/next_btn.png" alt="previous" />
          <div class="pagination" slot="pagination"></div>
          <img class="button-next" src="../assets/img/next_btn.png" alt="next" />
        </div>
      </div>
      <div v-else class="modal-selected-img">
        <img class="selected-img" :src="selectedImg" alt="ngoi den huyen thoai" />
        <action-buttons-component @share="onShare" @download="onDownloadImage" />
      </div>
      <button class="modal-back" @click="goBack">&lt; Back</button>
    </div>
  </modal-component>
</template>

<script lang="ts">
import { Component, Vue, Watch } from 'vue-property-decorator';
import ModalComponent from './Modal.vue';
import ActionButtonsComponent from './ActionButtons.vue';
import { commonModule, Orientation, Sharer } from '../store/common/const';
import { uploadModule } from '../store/upload/const';
import { CommonService } from '../services';
import { SHARE_HASHTAG } from '../constants';

@Component({
  components: { ModalComponent, ActionButtonsComponent }
})
export default class ModalLegendaryTempleComponent extends Vue {
  swiperOption = {
    pagination: {
      el: '.pagination',
      type: 'fraction'
    },
    paginationClickable: true,
    navigation: {
      nextEl: '.button-next',
      prevEl: '.button-prev'
    }
  };
  imgsPerPage = 12;
  selectedImg: string = '';

  @uploadModule.Action('uploadImage') uploadImage!: (imgData: string) => void;
  @commonModule.Action('toggleMvModal')
  toggleMvModal!: (isOpen: boolean) => void;
  @commonModule.Action('toggleTempleModal')
  toggleTempleModal!: (isOpen: boolean) => void;
  @uploadModule.Action('getAllTempleImages')
  getAllTempleImages!: () => void;

  @commonModule.State('orientation') orientation!: Orientation;
  @uploadModule.State('listLegendaryTemplesImg')
  protected list!: string[];
  @uploadModule.State('uploadedImageUrl') uploadedImageUrl!: string;

  @uploadModule.Getter('getUploadedImages')
  getUploadedImages!: any;

  @Watch('orientation', { immediate: true })
  orientationChange(val: Orientation) {
    this.imgsPerPage = val === Orientation.Portrait ? 12 : 15;
  }

  onSelectImage(img: string) {
    this.selectedImg = img;
  }

  clickBackdrop() {
    this.selectedImg = '';
    this.toggleTempleModal(false);
  }

  goBack() {
    if (this.selectedImg) {
      this.selectedImg = '';
    } else {
      this.toggleTempleModal(false);
    }
  }

  goBackToMv() {
    this.selectedImg = '';
    this.toggleTempleModal(false);
    this.toggleMvModal(true);
  }

  onDownloadImage() {
    CommonService.downloadImageFromUrl(this.selectedImg);
  }

  onShare() {
    CommonService.shareToFacebook(
      `http://www.facebook.com/sharer/sharer.php?u=${window.location.origin}${this.selectedImg}&hashtag=%23${SHARE_HASHTAG}`
    );
  }

  beforeMount() {
    this.getAllTempleImages();
  }
}
</script>

<style lang="scss" scoped>
.modal-temple {
  position: relative;
  width: 60vw;
  margin: 0 auto;

  .top-arrow {
    position: fixed;
    top: 0;
    left: 0;
    width: 100%;

    button {
      display: inline-block;
      transform: rotate(180deg);
      -webkit-transform: rotate(180deg);
      -moz-transform: rotate(180deg);
      -o-transform: rotate(180deg);
    }

    img {
      height: 4vh;
    }
  }

  .modal-logo {
    width: 60%;
    margin-bottom: 3vh;
  }

  .modal-list-wrapper {
    position: relative;

    .modal-list {
      width: 100%;

      .img-item-group {
        width: 100%;
        display: flex;
        flex-direction: row;
        flex-wrap: wrap;

        .img-item {
          position: relative;
          width: 33.333%;
          padding-bottom: 33.333%;

          &:hover {
            cursor: pointer;
          }

          img {
            position: absolute;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
          }
        }
      }
    }

    .modal-list-btns {
      display: flex;
      flex-direction: row;
      justify-content: center;
      align-items: center;
      margin-top: 2vh;

      .pagination {
        color: white;
        width: initial;
        margin: 0 10px;
        font-weight: bold;
        font-family: $primary-font;
      }

      img {
        width: 10px;
        outline: none;
      }

      .button-prev {
        -webkit-transform: scaleX(-1);
        -moz-transform: scaleX(-1);
        -o-transform: scaleX(-1);
        transform: scaleX(-1);

        filter: FlipH;
        -ms-filter: 'FlipH';
      }
    }
  }

  .modal-selected-img {
    .selected-img {
      width: 100%;
    }

    /deep/ .action-buttons {
      button {
        font-size: 2vh;

        svg {
          height: 2vh;
        }
      }
    }
  }

  .modal-back {
    background-color: transparent;
    color: white;
    border: none;
    font-family: $primary-font;
    font-style: italic;
    margin-top: 5vh;
    font-size: 2vh;
    outline: none;
  }
}

@include Responsive(MD) {
  .modal-temple {
    top: -6vh;
    width: 70vw;
  }
}

@include Orientation(Landscape) {
  .modal-temple {
    width: 40vw;
    top: 0;

    .modal-logo {
      width: 40%;
    }

    .modal-list-wrapper {
      .modal-list {
        .img-item-group {
          .img-item {
            position: relative;
            width: 20%;
            padding-bottom: 20%;
          }
        }
      }
    }

    .modal-selected-img {
      .selected-img {
        width: 60%;
      }
    }
  }
}
</style>